# coding: utf-8

"""
    Salesforce Platform API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class VrmV1JobsIngestJobIdPatch200Response(BaseModel):
    """
    Response from update close/abort job API.
    """ # noqa: E501
    api_version: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The API version that the job was created in.", alias="apiVersion")
    assignment_rule_id: Optional[StrictStr] = Field(default=None, description="The ID of an assignment rule to run for a Case or a Lead.", alias="assignmentRuleId")
    column_delimiter: Optional[StrictStr] = Field(default=None, description="The column delimiter used for CSV job data.", alias="columnDelimiter")
    concurrency_mode: Optional[StrictStr] = Field(default=None, description="For future use. How the request was processed. Currently only parallel mode is supported. (When other modes are added, the mode will be chosen automatically by the API and will not be user configurable.) ", alias="concurrencyMode")
    content_type: Optional[StrictStr] = Field(default=None, description="The content type for the job. The only valid value (and the default) is CSV.", alias="contentType")
    content_url: Optional[StrictStr] = Field(default=None, description="The URL to use for Upload Job Data requests for this job. Only valid if the job is in Open state.", alias="contentUrl")
    created_by_id: Optional[StrictStr] = Field(default=None, description="The ID of the user who created the job.", alias="createdById")
    created_date: Optional[StrictStr] = Field(default=None, description="The date and time in the UTC time zone when the job was created.", alias="createdDate")
    external_id_field_name: Optional[StrictStr] = Field(default=None, description="The name of the external ID field for an upsert.", alias="externalIdFieldName")
    id: Optional[StrictStr] = Field(default=None, description="Unique ID for this job.")
    job_type: Optional[StrictStr] = Field(default=None, description="The job’s type.", alias="jobType")
    line_ending: Optional[StrictStr] = Field(default=None, description="The line ending used for CSV job data, marking the end of a data row. The default is LF.", alias="lineEnding")
    object: Optional[StrictStr] = Field(default=None, description="The object type for the data being processed. Use only a single object type per job.")
    operation: Optional[StrictStr] = Field(default=None, description="The processing operation for the job.")
    state: Optional[StrictStr] = Field(default=None, description="The current state of processing for the job")
    system_modstamp: Optional[StrictStr] = Field(default=None, description="Date and time in the UTC time zone when the job finished.", alias="systemModstamp")
    __properties: ClassVar[List[str]] = ["apiVersion", "assignmentRuleId", "columnDelimiter", "concurrencyMode", "contentType", "contentUrl", "createdById", "createdDate", "externalIdFieldName", "id", "jobType", "lineEnding", "object", "operation", "state", "systemModstamp"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VrmV1JobsIngestJobIdPatch200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VrmV1JobsIngestJobIdPatch200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "apiVersion": obj.get("apiVersion"),
            "assignmentRuleId": obj.get("assignmentRuleId"),
            "columnDelimiter": obj.get("columnDelimiter"),
            "concurrencyMode": obj.get("concurrencyMode"),
            "contentType": obj.get("contentType"),
            "contentUrl": obj.get("contentUrl"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "externalIdFieldName": obj.get("externalIdFieldName"),
            "id": obj.get("id"),
            "jobType": obj.get("jobType"),
            "lineEnding": obj.get("lineEnding"),
            "object": obj.get("object"),
            "operation": obj.get("operation"),
            "state": obj.get("state"),
            "systemModstamp": obj.get("systemModstamp")
        })
        return _obj


