# coding: utf-8

"""
    Salesforce Platform API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from generated.models.vrm_v1_vendors_grid_id_cases_post_request_product_request_inner import VrmV1VendorsGridIdCasesPostRequestProductRequestInner
from typing import Optional, Set
from typing_extensions import Self

class VrmV1VendorsGridIdCasesPostRequest(BaseModel):
    """
    Vendor case creation request. product_request is required for Master Product Creation case type
    """ # noqa: E501
    type: StrictStr = Field(description="Type of the case")
    origin: StrictStr = Field(description="case Origin")
    subject: Optional[StrictStr] = Field(default=None, description="Subject for the menu change/master product creation request")
    description: Optional[StrictStr] = None
    product_request: Optional[List[VrmV1VendorsGridIdCasesPostRequestProductRequestInner]] = Field(default=None, description="Master Product Requests")
    __properties: ClassVar[List[str]] = ["type", "origin", "subject", "description", "product_request"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VrmV1VendorsGridIdCasesPostRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in product_request (list)
        _items = []
        if self.product_request:
            for _item_product_request in self.product_request:
                if _item_product_request:
                    _items.append(_item_product_request.to_dict())
            _dict['product_request'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VrmV1VendorsGridIdCasesPostRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "origin": obj.get("origin"),
            "subject": obj.get("subject"),
            "description": obj.get("description"),
            "product_request": [VrmV1VendorsGridIdCasesPostRequestProductRequestInner.from_dict(_item) for _item in obj["product_request"]] if obj.get("product_request") is not None else None
        })
        return _obj


